/// <reference types="lodash/common/common" />
/// <reference types="lodash/common/array" />
/// <reference types="lodash/common/collection" />
/// <reference types="lodash/common/date" />
/// <reference types="lodash/common/function" />
/// <reference types="lodash/common/lang" />
/// <reference types="lodash/common/math" />
/// <reference types="lodash/common/number" />
/// <reference types="lodash/common/object" />
/// <reference types="lodash/common/seq" />
/// <reference types="lodash/common/string" />
/// <reference types="lodash/common/util" />
import { JSONSchema6 } from 'json-schema';
import { FilterSignature } from '.';
export declare const FULL_TEXT_SLUG = "full_text_search";
export declare const filter: (filters: JSONSchema6 | JSONSchema6[], collection: any[]) => any[] | import("lodash").Dictionary<unknown>;
export declare const createFullTextSearchFilter: (schema: JSONSchema6, term: string) => JSONSchema6;
export declare const upsertFullTextSearch: (schema: JSONSchema6, filters: JSONSchema6[] | undefined, term: string) => JSONSchema6[];
export declare const removeFullTextSearch: (filters: JSONSchema6[]) => JSONSchema6[];
export declare const createFilter: (schema: JSONSchema6, signatures: FilterSignature[]) => JSONSchema6;
export declare const decodeFilter: (schema: JSONSchema6, filter: JSONSchema6) => ({} | null)[];
export declare const getOperators: (schema: JSONSchema6, field: string) => {
    slug: string;
    label: any;
}[];
export declare const flattenSchema: (schema: JSONSchema6, delimiter?: string) => JSONSchema6;
export declare const unflattenSchema: (schema: JSONSchema6, delimiter?: string) => JSONSchema6;
export declare const getCleanEditModel: (schema: JSONSchema6, field?: string | null | undefined) => {
    field: string;
    operator: string;
    value: any;
};
