"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var react_notifications_component_1 = __importStar(require("react-notifications-component"));
var styled_components_1 = __importDefault(require("styled-components"));
var animations_1 = require("../../animations");
var DismissableContainer_1 = require("../../internal/DismissableContainer");
var defaultStyle_1 = __importDefault(require("./defaultStyle"));
var NOTIFICATION_WIDTH = 300;
var DEFAULT_NOTIFICATION_DURATION = 6000;
var FullWidthContainer = styled_components_1.default(DismissableContainer_1.DismissableContainer)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\twidth: 100%;\n"], ["\n\twidth: 100%;\n"])));
var enterExitAnimation = {
    duration: 200,
    timingFunction: 'linear',
    delay: 0,
};
var generateNotificationId = function () {
    return Math.random()
        .toString(36)
        .substr(2, 9);
};
var getTransformedOptions = function (options) {
    var defaultOptions = {
        id: generateNotificationId(),
        duration: DEFAULT_NOTIFICATION_DURATION,
    };
    if (typeof options === 'string' || React.isValidElement(options)) {
        return __assign({ content: options }, defaultOptions);
    }
    else {
        return __assign(__assign({}, defaultOptions), options);
    }
};
var NotificationContainer = function (_a) {
    var children = _a.children, baselineHeight = _a.baselineHeight, onDismiss = _a.onDismiss, id = _a.id;
    return (React.createElement(FullWidthContainer, { baselineHeight: baselineHeight, onDismiss: function () {
            if (onDismiss) {
                onDismiss();
            }
            react_notifications_component_1.store.removeNotification(id);
        } }, children));
};
exports.NotificationsContainer = styled_components_1.default(react_notifications_component_1.default)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\t", "\n\t", "\n\n\tposition: fixed;\n\tz-index: 9000;\n\tpointer-events: none;\n\twidth: 100%;\n\theight: 100%;\n\n\t/* This overrides the react-notification library's default container shadow */\n\t.notification-item {\n\t\tbox-shadow: none;\n\t}\n"], ["\n\t", "\n\t", "\n\n\tposition: fixed;\n\tz-index: 9000;\n\tpointer-events: none;\n\twidth: 100%;\n\theight: 100%;\n\n\t/* This overrides the react-notification library's default container shadow */\n\t.notification-item {\n\t\tbox-shadow: none;\n\t}\n"])), animations_1.animations, defaultStyle_1.default);
exports.notifications = {
    addNotification: function (options) {
        var transformedOptions = getTransformedOptions(options);
        react_notifications_component_1.store.addNotification({
            container: 'top-right',
            animationIn: ['animated', 'fadeIn', 'faster'],
            animationOut: ['animated', 'fadeOut', 'faster'],
            slidingEnter: enterExitAnimation,
            slidingExit: enterExitAnimation,
            touchRevert: enterExitAnimation,
            touchSlidingExit: {
                swipe: enterExitAnimation,
                fade: enterExitAnimation,
            },
            dismiss: {
                duration: transformedOptions.duration,
                pauseOnHover: true,
                waitForAnimation: false,
                click: false,
                touch: false,
            },
            width: NOTIFICATION_WIDTH,
            id: transformedOptions.id,
            content: (React.createElement(NotificationContainer, { baselineHeight: transformedOptions.baselineHeight, onDismiss: transformedOptions.onDismiss, id: transformedOptions.id }, transformedOptions.content)),
        });
    },
    removeNotification: function (id) { return react_notifications_component_1.store.removeNotification(id); },
};
var templateObject_1, templateObject_2;
