"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var BreakpointContext_1 = require("../contexts/BreakpointContext");
var theme_1 = require("../theme");
exports.useBreakpoint = function (values) {
    if (values.length > theme_1.breakpoints.length) {
        throw new Error("There should be no more than " + theme_1.breakpoints.length + " value entries");
    }
    var currentBreakpoint = React.useContext(BreakpointContext_1.BreakpointContext).currentBreakpoint;
    var missingValues = Array(theme_1.breakpoints.length - values.length).fill(values[values.length - 1]);
    var newValues = __spreadArrays(values, missingValues);
    return newValues[currentBreakpoint];
};
