import { __assign, __makeTemplateObject, __rest } from "tslib";
import assign from 'lodash/assign';
import * as React from 'react';
import styled from 'styled-components';
import asRendition from '../../asRendition';
import { generateColorFromString, getColor, isLight } from '../../utils';
import Txt from '../Txt';
var BaseHighlightedName = styled(Txt.span)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tfont-family: ", ";\n\tdisplay: inline-block;\n\tborder-radius: 2px;\n\tline-height: 1;\n"], ["\n\tfont-family: ", ";\n\tdisplay: inline-block;\n\tborder-radius: 2px;\n\tline-height: 1;\n"])), function (props) { return props.theme.titleFont; });
var HighlightedName = function (_a) {
    var children = _a.children, className = _a.className, theme = _a.theme, color = _a.color, props = __rest(_a, ["children", "className", "theme", "color"]);
    if (typeof children !== 'string') {
        throw new Error("The child element of the HighlightedName component must be a string, received: " + typeof children);
    }
    var bgColor = getColor(assign(props, { theme: theme }), 'bg', 'main') ||
        generateColorFromString(children);
    return (React.createElement(BaseHighlightedName, __assign({}, props, { className: className, p: 2, fontSize: 1, color: color || isLight(bgColor) ? theme.colors.text.main : '#fff', bg: bgColor }), children));
};
export default asRendition(HighlightedName, [], ['bg', 'color']);
var templateObject_1;
