import { __spreadArrays } from "tslib";
import * as React from 'react';
import { BreakpointContext } from '../contexts/BreakpointContext';
import { breakpoints } from '../theme';
export var useBreakpoint = function (values) {
    if (values.length > breakpoints.length) {
        throw new Error("There should be no more than " + breakpoints.length + " value entries");
    }
    var currentBreakpoint = React.useContext(BreakpointContext).currentBreakpoint;
    var missingValues = Array(breakpoints.length - values.length).fill(values[values.length - 1]);
    var newValues = __spreadArrays(values, missingValues);
    return newValues[currentBreakpoint];
};
